/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.hk;

import java.util.List;

/**
 *
 * @author Jahan
 *
 * 
 *
 * l'implémentation pourra être obtenue, par le biais de
 * fr.hk.engine.HkFactory.getImplementation()
 *
 */
public interface HkFunctions {

    /**
     * the abstract configuration of the HkEngine
     */
    public interface HkConfig{
    }

    /**
     * the abstract result from processing an input text.
     */
    public interface HkResult{
        byte[] getBytes();
    }

    /**
     *
     * @param currentContext    null to begin the configuration process, or a config to update
     * @param input a HK config input byte array (can be null, in order to start the building of the config)
     * @return the update HKConfig (the input instance is returned), or the new HKConfig
     */
    public HkConfig inputConfig(HkConfig currentContext,byte[] input) throws HkException,HkIllegalConfiguration;

    /**
     *
     * @param config Hk engine configuration
     * @param text the text to process
     * @return an abstract result
     * @throws fr.hk.HkFunctions.HkException
     * @throws fr.hk.HkFunctions.HkIllegalConfiguration
     */
    public HkResult analyse(HkConfig config,String text) throws HkException,HkIllegalConfiguration;

    /**
     *
     * @param config Hk engine configuration
     * @param analysisResult an abstract result from the analyse process
     * @return the list of categories that the abstract analysisResult points to
     * @throws fr.hk.HkFunctions.HkException
     */
    public List<String> categorize(HkConfig config,HkResult analysisResult) throws HkException;

    public List<String> getAllCategories(HkConfig config);

    public static class HkException extends Exception{
        static final long serialVersionUID=0xCEA;
    }
    public static class HkIllegalConfiguration extends HkException{
    }


}
